#!/usr/bin/perl

##########################################
##########################################
##                                      ##
##     bforce ##
## (c) Sln ! (Leonid Subbotin)          ##
## addr: 2:5007/16, sln@khakasnet.ru    ##
##                                      ##
##########################################
##########################################

#    
$line="ttyS0";
#  ,    ( )
# $line="ttyS0, tcpip, ttyS1";

#    
#   /      . 
#   /var/log/bf-log.ttyS0, /var/log/bf-log.tcpip,  ..
$log="/var/log/ifmail/bf-log";

# history
$hist="/var/log/ifmail/bf-history";

#         
$stat="/tmp";

#    
$copy="\nBF Stat v1.0 (c) Sln !";

###################################################################################################################

print "
$copy
  Usage: $0 key1 key2 ...
       Keys:
	in    -  inbound
	out   -  outbound
	full  -   
	info  -  
	top   - 
	graph - 
	all   -
" and exit unless @ARGV;

open(HIST,$hist) || die $!;
@hist=<HIST>;
close HIST;


undef @log;
foreach(split /,\s*/,$line){
next unless open(LOG,"$log.$_");
push @log, <LOG>;
close LOG;
}

die "AAA!   ?" unless @log;



# get information about links
undef %addr;;
undef %system;
undef %tel;
undef %sysop;
undef %mailer;

LINE: for $i(0..$#log){
$pid=$adr=$system=$tel=$sysop=$mailer=undef;

if($log[$i]=~/\[(\d+)\]\s+address : (\d+:\d+\/\d+[\.\d+]*)/i){
($pid,$adr)=($1,$2);

for $j(1..20){                     next LINE if $log[$i-$j] and $log[$i-$j]=~/\[$pid\]\s+address : \d/i;               }
for $j(1..20){  ($system,$tel)=($1,$2), last if $log[$i+$j] and $log[$i+$j]=~/\[$pid\]\s+system : (.+) \((.+)\)$/i;    }
for $j(2..21){  $sysop=$1,              last if $log[$i+$j] and $log[$i+$j]=~/\[$pid\]\s+sysop : (.+) from /i;         }
for $j(3..22){  $mailer="$1/$2",        last if $log[$i+$j] and $log[$i+$j]=~/\[$pid\]\s+mailer : (.+) \[\w+\] (.+)/i; }

next if !$system or !$tel or !$sysop or !$mailer;
($addr{$adr},$system{$adr},$tel{$adr},$sysop{$adr},$mailer{$adr})=($adr,$system,$tel,$sysop,$mailer);

}
}




# get statistic form history
$line=~s/[,\s*]+/\|/g;
$line=~s/([^\w\|])/\\$1/g;

undef %c;
undef %o;
undef %f;
undef %s;
undef %r;
$tc=$to=$tf=$ts=$tr=0;

foreach(@hist){

if(/^(?:$line),(\d+:\d+\/\d+[\.\d+]*),(\d+),(\d+),(\w+),\d+,(\d+),(\d+),(\d+),(\d+),(\d+),(\d+)/i){
($addr,$time,$online,$ses,$sent,$recv)=($1,$2,$3,$4,$5+$6+$7,$8+$9+$10);
( $in_t{$time}, $in_o{$time}, $in_s{$time}, $in_r{$time})=($addr,$online,$sent,$recv) if $ses=~/i/i;
($out_t{$time},$out_o{$time},$out_s{$time},$out_r{$time})=($addr,$online,$sent,$recv) if $ses=~/o/i;

$c{$addr}++;
$o{$addr}+=$online;
$f{$addr}+=$online if $sent or $recv;
$s{$addr}+=$sent;
$r{$addr}+=$recv;

$tc++;
$to+=$online;
$tf+=$online if $sent or $recv;
$ts+=$sent;
$tr+=$recv;
}

}



foreach(keys %addr){ $system{$_}=$_ unless exists $c{$_} }
foreach(keys %c){ $system{$_}=$_ unless exists $addr{$_} }



@ARGV=('in','out','full','info','top','graph') if $ARGV[0] eq 'all';
%us=map {lc($_),''} @ARGV;

mkdetal("$stat/stat.in", "Inbound session", \%in_t, \%in_o, \%in_s, \%in_r)				if exists $us{'in'};
mkdetal("$stat/stat.out","Outbound session",\%out_t,\%out_o,\%out_s,\%out_r)                            if exists $us{'out'};
mkfull("$stat/stat.full","Whole period")                                                                if exists $us{'full'};
mkinfo("$stat/stat.info","About sysop","Systems","Mailer usage")                                        if exists $us{'info'};
tops("$stat/stat.top",   "Top 10 CPS","Top 10 call","Top 10 online","Top 10 download","Top 10 upload")  if exists $us{'top'};
mkgraph("$stat/stat.graph",20,"Average telephone calls","Average line employment")                                           if exists $us{'graph'};
#                          ^^     ( 0,  1  1)







exit;


#########################################################################################
sub mkdetal{
($file,$subj,*time,*online,*sent,*recv)=@_;
@mon=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

open(DETAL,">$file") || die $!;
print DETAL "$subj\n";

$nd=0;$date=32;
$end="\n";

foreach(sort{$a<=>$b} keys %time){

($time,$date,$mon)=t2s($_,2);

if($nd != $date){
print DETAL $end if $nd;
print DETAL "$date $mon[$mon]\n";
print DETAL "\n";
print DETAL "              System              |   Time   |  Online  | Sent | Recv | CPS \n";
print DETAL "\n";
$nd=$date;
}

$system=$system{$time{$_}};

$online=t2s($online{$_});

$sent=b2s($sent{$_});
$recv=b2s($recv{$_});

(($sent{$_} or $recv{$_}) and $online{$_}) ? ($cps=int(($sent{$_}+$recv{$_})/$online{$_})) : ($cps="-");

write(DETAL);
}

print DETAL $end if $date != 32;
print DETAL $copy;
close DETAL;
}


#########################################################################################
sub mkfull{
($file,$subj)=@_;

open(FULL,">$file") || die $!;
print FULL "$subj\n";
print FULL "\n";
print FULL "             System              |Calls| Online |  Sent |  Recv | CPS \n";
print FULL "\n";

foreach(sort{uc($system{$a}) cmp uc($system{$b})} keys %c){

$online=t2s($o{$_});
$sent=b2s($s{$_});
$recv=b2s($r{$_});

$f{$_} ? ($cps=int(($s{$_}+$r{$_})/$f{$_})) : ($cps="-");

write(FULL);
}


print FULL "\n";
$_="t";

$system{$_}=(scalar keys %c)." systems";;

$c{$_}=$tc;

$online=t2s($to,1);

$sent=b2s($ts);
$recv=b2s($tr);

$tf ? ($cps=int(($ts+$tr)/$tf)) : ($cps="=");

write(FULL);

delete $system{$_};
delete $c{$_};

print FULL "\n";
print FULL $copy;
close FULL;
}


#########################################################################################
sub mkinfo{
($file,@subj)=@_;

open(SYSOP,">$file") || die $!;
print SYSOP "$subj[1]\n";
print SYSOP "\n";
print SYSOP "     Address    |          Name           |       Telephone      \n";
print SYSOP "\n";
write(SYSOP) foreach(sf(keys %addr));
print SYSOP "\n";
close SYSOP;

open(SYS,">>$file") || die $!;
print SYS "$subj[0]\n";
print SYS "\n";
print SYS "     Address    |                     System                     \n";
print SYS "\n";
write(SYS) foreach(sf(keys %addr));
print SYS "\n";
close SYS;

open(MAILER,">>$file") || die $!;
print MAILER "$subj[2]\n";
print MAILER "\n";
print MAILER "     Address    |                     Mailer                     \n";
print MAILER "\n";
write(MAILER) foreach(sf(keys %addr));
print MAILER "\n";

print MAILER $copy;
close MAILER;
}


#########################################################################################
sub mkgraph{
($file,$h,@subj)=@_;

undef @_;
push @_, keys %in_t, keys %out_t;
@_=sort{$a<=>$b} @_;
$_=($_[-1]-$_[0])/86400;
$p=int($_);
$p+=1 if $p!=$_;

(*ci,*oi)=mkh(\%in_t, \%in_o, $p);
%cin=%ci;%oin=%oi;

(*co,*oo)=mkh(\%out_t,\%out_o,$p);
%cout=%co;%oout=%oo;

open(GR,">$file") || die $!;

gr($subj[0],$h,"calls",\%cin,\%cout);
gr($subj[1],$h,"min",  \%oin,\%oout);

print GR "       - outbound   - inbound   - in and out\n";
print GR "      For period in $p days\n";
print GR $copy;
close GR;
}



sub mkh{
undef %rc;
undef %ro;

(*time,*online,$p)=@_;

foreach(keys %time){

@_=(localtime($_))[0..2];
$x=int((($_[2]*60+$_[1])*60+$_[0])/1800);

$rc{$x}++;

$y=$online{$_}/60;

while($y > 30){
  $y-=30;
  $ro{$x}+=30;
  $x>=47 ? ($x=0) : ($x++);
}
  $ro{$x}+=$y;

}

foreach(keys %rc){$rc{$_}=$rc{$_}/$p }
foreach(keys %ro){$ro{$_}=$ro{$_}/$p }
return(\%rc,\%ro);
}




sub gr{
($s,$h,$r,*i,*o)=@_;

undef @_;
push @_, values %i, values %o;
@_=sort{$a<=>$b} @_;

$h ? ($y=$h) : ($y=$_[-1]);
$x=$_[-1]/$y;

print GR "$s\n";
print GR "  $r\n";
print GR "   \n";

$o=0;

for($j=$y;$j>=0;$j--){

$v=int($j*$x+1);
$o==$v ? $v="" : $o=$v;

print GR sprintf("% 3s",$v);

for $i(0..47){
$ch=' ';
$ch='' if exists $o{$i} and $o{$i} >= $j*$x;
$ch='' if exists $i{$i} and $i{$i} >= $j*$x;
$ch='' if exists $i{$i} and exists $o{$i} and $i{$i} >= $j*$x and $o{$i} >= $j*$x;
print GR $ch;
}

print GR "\n";
}

print GR "   time of day\n";
print GR "  0    2   4   6   8  10  12  14  16  18  20  22  24\n\n";
}


#########################################################################################
sub tops{
($file,@subj)=@_;

open(TOPS,">$file") || die $!;

# top 10 cps
foreach(keys %c){ $f{$_} ? ($cps{$_}=int(($s{$_}+$r{$_})/$f{$_})) : ($cps{$_}=0) }
pt($subj[0],\%cps);


# top 10 calls
pt($subj[1],\%c);


# top 10 online
pt($subj[2],\%o,2);


# top 10 dl
pt($subj[3],\%s,1);


# top 10 ul
pt($subj[4],\%r,1);

print TOPS $copy;
close TOPS;
}



sub pt{
($subj,*h,$t)=@_;

$i=1;
$s="\n";
$e="\n";

print TOPS "$subj\n";
print TOPS $s;
@t=sort{$h{$b}<=>$h{$a}} keys %h;
foreach(splice @t,0,10){
$val=$h{$_};
$val=b2s($h{$_}) if $t and $t == 1;
$val=t2s($h{$_},1) if $t and $t == 2;
write(TOPS);
}
print TOPS $e;
}


#########################################################################################
sub t2s{
if($_[1] and $_[1] == 2){
 @_=localtime($_[0]);
 return(sprintf("%02d:%02d:%02d",$_[2],$_[1],$_[0]),$_[3],$_[4]);
}elsif($_[1] and $_[1] == 1){
 @_=gmtime($_[0]);
 return sprintf("%02dd %02dh",$_[3]-1,$_[2]) if $_[3]-1 > 0;
 return sprintf("%02dh %02dm",$_[2],$_[1]) if $_[2] > 0;
 return sprintf("%02dm %02ds",$_[1],$_[0]) if $_[1] > 0;
}else{
 return "-" unless $_[0];
 @_=gmtime($_[0]);
 return sprintf("%02d:%02d:%02d",$_[2],$_[1],$_[0]);
}
}




sub b2s{
my $str=shift;
return (int($str/1024**3*10)/10)."g" if $str >= 1_000_000_000;
return (int($str/1024**2*10)/10)."m" if $str >= 1_000_000;
return (int($str/1024*10)/10)   ."k" if $str >= 1_000;
return $str."b" if $str;
"-";
}


sub sf{
 map{$_->[0]} sort{$a->[1] <=> $b->[1] || $a->[2] <=> $b->[2] || $a->[3] <=> $b->[3] || $a->[4] <=> $b->[4]} map{[$_, split m![:/.]!]} @_;
}


#########################################################################################
format DETAL =
 @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< | @<<<<<<< | @>>>>>>> |@>>>>>|@>>>>>|@>>>>
$system,                             $time,     $online,  $sent, $recv, $cps
.


format FULL =
 @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<|@>>>>|@>>>>>>>| @>>>>>| @>>>>>|@>>>>
  $system{$_},                    $c{$_},$online,  $sent,  $recv, $cps
.

format SYS =
 @<<<<<<<<<<<<< | @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
$_,                $system{$_}
.

format SYSOP =
 @<<<<<<<<<<<<< | @<<<<<<<<<<<<<<<<<<<<<< | @<<<<<<<<<<<<<<<<<<< 
$_,                $sysop{$_},               $tel{$_}
.

format MAILER =
 @<<<<<<<<<<<<< | @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< 
$_,                $mailer{$_}
.

format TOPS =
@>| @<<<<<<<<<<<<<<<<<<<<<<<<<<<<< | @>>>>>>> 
$i++,$system{$_},                     $val
.
